--- old/usr/src/head/ucontext.h	Tue Aug 12 07:52:09 2014
+++ new/usr/src/head/ucontext.h	Tue Aug 12 07:52:09 2014
@@ -26,6 +26,9 @@
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
+ */
 
 #ifndef _UCONTEXT_H
 #define	_UCONTEXT_H
@@ -40,6 +43,14 @@
 extern "C" {
 #endif
 
+/*
+ * Arguably, under _XPG7, applications should not even include this
+ * header, since it isn't part of Issue 7.  We apply some paranoia for
+ * the functions that were explicity removed, although we could likely
+ * just ignore the darn thing altogether.
+ */
+#if (!defined(_STRICT_SYMBOLS)) || (defined(_XPG4_2) && !defined(_XPG7))
+
 #ifdef __sparc
 #ifdef __PRAGMA_REDEFINE_EXTNAME
 #pragma	redefine_extname	makecontext	__makecontext_v2
@@ -48,8 +59,6 @@
 #endif
 #endif
 
-#if defined(__STDC__)
-
 extern int getcontext(ucontext_t *) __RETURNS_TWICE;
 #pragma unknown_control_flow(getcontext)
 extern int setcontext(const ucontext_t *) __NORETURN;
@@ -56,6 +65,8 @@
 extern int swapcontext(ucontext_t *_RESTRICT_KYWD,
 		const ucontext_t *_RESTRICT_KYWD);
 extern void makecontext(ucontext_t *, void(*)(), int, ...);
+#endif /* !_STRICT_SYMBOLS || _XGP4_2 && ! _XPG7 */
+
 #if !defined(_XPG4_2) || defined(__EXTENSIONS__)
 extern int walkcontext(const ucontext_t *, int (*)(uintptr_t, int, void *),
     void *);
@@ -71,29 +82,7 @@
 
 extern void *_stack_grow(void *);
 #endif
-#else
 
-extern int getcontext() __RETURNS_TWICE;
-#pragma unknown_control_flow(getcontext)
-extern int setcontext();
-extern int swapcontext();
-extern void makecontext();
-#if !defined(_XPG4_2) || defined(__EXTENSIONS__)
-extern int walkcontext();
-extern int printstack();
-extern int addrtosymstr();
-extern int getustack();
-extern int setustack();
-
-extern int stack_getbounds();
-extern int stack_setbounds();
-extern int stack_inbounds();
-extern int stack_violation();
-
-extern void *_stack_grow();
-#endif
-#endif
-
 #ifdef	__cplusplus
 }
 #endif
